---
id: installation
title: Installation
---

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';
import CodeBlock from '@theme/CodeBlock';
import { getLatestVersion } from '@site/src/components/Version';

### Preresquisities

- Gradle 7 or higher
  - Koremods Gradle is built for this version of Gradle
  - Koremods Script uses
    [Gradle Module Metadata](https://docs.gradle.org/current/userguide/publishing_gradle_module_metadata.html)
    and variant aware matching to manage its dependencies, supported since Gradle 6.
- An IDE of your choice
  - We recommend [IntelliJ IDEA](https://www.jetbrains.com/idea/) for the best experience
    thanks to its awesome Gradle and Kotlin integration.

## Gradle setup

### Apply the Koremods Gradle plugin

First, add the Garden of Fancy releases maven repository to your plugin repositories. We also provide 2 additional
repositories for unstable versions. However, using them is not recommended, and you should only do so at your own risk.

- Garden of Fancy Snapshots: `https://maven.gofancy.wtf/snapshots`
- Garden of Fancy Bleeding: `https://maven.gofancy.wtf/bleeding`

````mdx-code-block
<Tabs>
<TabItem value="groovy" label="Groovy DSL">

```groovy
pluginManagement {
  repositories {
    maven {
      name 'Garden of Fancy'
      url 'https://maven.gofancy.wtf/releases'
    }
  }
}
```

</TabItem>
<TabItem value="kotlin" label="Kotlin DSL">

```kotlin
pluginManagement {
  repositories {
    maven {
      name = "Garden of Fancy"
      url  = uri("https://maven.gofancy.wtf/releases")
    }
  }
}
```

</TabItem>
</Tabs>
````

Then, apply the plugin using the Plugins DSL:

<Tabs>
<TabItem value="groovy" label="Groovy DSL">

<CodeBlock language="groovy">
{`plugins {
  id 'wtf.gofancy.koremods.gradle' version '${getLatestVersion('koremods-gradle')}'
}`}
</CodeBlock>

</TabItem>
<TabItem value="kotlin" label="Kotlin DSL">

<CodeBlock language="kotlin">
{`plugins {
  id("wtf.gofancy.koremods.gradle") version "${getLatestVersion('koremods-gradle')}"
}`}
</CodeBlock>

</TabItem>
</Tabs>

### Add the Koremods dependency

The `koremods` gradle configuration contains frontend dependencies used for the script compilation classpath. To add
the Koremods Modlauncher frontend to your environment, simply declare a dependency on it.

Koremods takes advantage of Gradle variants to add required dependencies to the compile classpath and enable syntax
highlighting in koremods scripts.
No additional runtime dependencies are added, as those are bundled inside the main jar.

<Tabs>
<TabItem value="groovy" label="Groovy DSL">

<CodeBlock language="groovy">
{`repositories {
  maven {
    name 'Garden of Fancy'
    url 'https://maven.gofancy.wtf/releases'
  }
}

dependencies {
  koremods group: 'wtf.gofancy.koremods', name: 'koremods-modlauncher', version: '${getLatestVersion('koremods-modlauncher')}'
}`}
</CodeBlock>

</TabItem>
<TabItem value="kotlin" label="Kotlin DSL">

<CodeBlock language="kotlin">
{`repositories {
  maven {
    name = "Garden of Fancy"
    url = uri("https://maven.gofancy.wtf/releases")
  }
}

dependencies {
  koremods(group = "wtf.gofancy.koremods", name = "koremods-modlauncher", version = "${getLatestVersion('koremods-modlauncher')}")
}`}
</CodeBlock>

</TabItem>
</Tabs>

With the dependencies installed, you can now proceed to configuring the script pack and runtime.
